#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
vector<pair<int, int>> qwe = {{-1, -1}};

vector<pair<int, int>> f(vector<int> p, int s) {
    map<int, int> mp, mp1;
    mp[0] = -1;
    for (int i = 0; i < (int) p.size(); ++i) {
        mp1 = mp;
        for (auto [it1, it2]: mp) {
            if (it1 + p[i] <= s && mp1.find(it1 + p[i]) == mp1.end()) {
                mp1[it1 + p[i]] = i;
            }
        }
        mp = mp1;
    }
    if (mp.find(s) == mp.end()) {
        return qwe;
    }
    vector<pair<int, int>> ans;
    set<int> st;
    int pos = mp[s], S = s;
    st.insert(pos);
    while (pos != -1) {
        int pos1 = mp[S - p[pos]];
        S = S - p[pos];
        pos = pos1;
        if (pos == -1) {
            break;
        }
        st.insert(pos);
    }
    for (int i = 0; i < (int) p.size(); ++i) {
        if (st.find(i) == st.end()) {
            ans.emplace_back(1, i + 1);
        }
    }
    return ans;
}

const int N = 15;
int a[N][N], h, w, s;

signed main() {
    fast_in_out();
    cin >> h >> w;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
        }
    }
    cin >> s;
    for (int mask = 0; mask < (1 << w); ++mask) {
        vector<int> p(h);
        for (int j = 0; j < w; ++j) {
            if (!((mask >> j) & 1)) {
                for (int i = 0; i < h; ++i) {
                    p[i] += a[i][j];
                }
            }
        }
        vector<pair<int, int>> ans = f(p, s);
        if (ans == qwe) {
            continue;
        }
        for (int j = 0; j < w; ++j) {
            if (((mask >> j) & 1)) {
                ans.emplace_back(2, j + 1);
            }
        }
        cout << "YES\n" << (int) ans.size() << '\n';
        for (auto [it1, it2]: ans) {
            cout << it1 << ' ' << it2 << '\n';
        }
        return 0;
    }
    cout << "NO";
    return 0;
}
