#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
const int N = 2e3, K = 1e3, inf = 1e9;
vector<int> g[N];
int n, k, t, h[N], Par[N], dp[N][N];
vector<int> hes;

int la(int v, int d) {
    while (d--) {
        v = Par[v];
    }
    return v;
}

void dfs(int v, int p = -1) {
    if (p == -1) {
        h[v] = 0;
        Par[v] = -1;
        hes.emplace_back(1);
    }
    for (auto to: g[v]) {
        if (to != p) {
            Par[to] = v;
            h[to] = h[v] + 1;
            if ((int) hes.size() == h[to]) {
                hes.emplace_back(1);
            } else {
                ++hes[h[to]];
            }
            dfs(to, v);
        }
    }
}

void dfs1(int v, int d, int p = -1) {
    if (h[v] > 1) {
        dp[v][1] = 1;
    }
    int sm = 0;
    for (auto to: g[v]) {
        if (to != p) {
            dfs1(to, d, v);
            sm += dp[to][1];
            for (int i = 2; i <= min(d, h[to]); ++i) {
                dp[v][i - 1] += min(dp[to][i], dp[to][1]);
            }
        }
    }
    if (d <= h[v]) {
        dp[v][d] = sm;
    }
    if (p == -1) {
        for (auto to: g[v]) {
            dp[v][0] += dp[to][1];
        }
    }
}

int ans(int v) {
    hes.clear();
    dfs(v);
    if (k + 1 + (int) g[v].size() >= n) {
        return 1;
    }
    for (int d = 2; d < (int) hes.size(); ++d) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dp[i][j] = 0;
            }
        }
        dfs1(v, d);
        if (dp[v][0] <= k) {
            return d;
        }
    }
    return (int) hes.size();
}

signed main() {
    fast_in_out();
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        g[q].emplace_back(w);
        g[w].emplace_back(q);
    }
    if (t == 0) {
        cout << ans(0);
    } else {
        for (int i = 0; i < n; ++i) {
            cout << ans(i) << '\n';
        }
    }
    return 0;
}
