#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
const int N = 2e5;
vector<int> g[N], dp[N];
int n, k, t, h[N], hes;

void dfs(int v, int p = -1) {
    if (p == -1) {
        h[v] = 0;
    }
    hes = max(hes, h[v]);
    for (auto to: g[v]) {
        if (to != p) {
            h[to] = h[v] + 1;
            dfs(to, v);
        }
    }
}

void dfs1(int v, int d, int p = -1) {
    if (h[v] > 1) {
        dp[v][1] = 1;
    }
    int sm = 0;
    for (auto to: g[v]) {
        if (to != p) {
            dfs1(to, d, v);
            sm += dp[to][1];
            for (int i = 2; i <= min(d, h[to]); ++i) {
                dp[v][i - 1] += min(dp[to][i], dp[to][1]);
            }
        }
    }
    if (d <= h[v]) {
        dp[v][d] = sm;
    }
    if (p == -1) {
        for (auto to: g[v]) {
            dp[v][0] += dp[to][1];
        }
    }
}

int ans(int v) {
    dfs(v);
    if (k + 1 + (int) g[v].size() >= n) {
        return 1;
    }
    int l = 1, r = hes;
    while (r - l > 1) {
        int d = (l + r) / 2;
        for (int i = 0; i < n; ++i) {
            dp[i].clear();
            dp[i].resize(d + 1);
        }
        dfs1(v, d);
        if (dp[v][0] <= k) {
            r = d;
        } else {
            l = d;
        }
    }
    return r;
}

signed main() {
    fast_in_out();
    cin >> n >> k >> t;
    for (int i = 0; i < n - 1; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        g[q].emplace_back(w);
        g[w].emplace_back(q);
    }
    if (t == 0) {
        cout << ans(0);
    } else {
        for (int i = 0; i < n; ++i) {
            cout << ans(i) << '\n';
        }
    }
    return 0;
}
