#include <bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

using ll = long long;
#define int long long
const int N = 2e5, ing = 1e9;
int a[N], t[N], n;

int pw(int l) {
    int ans = 1;
    while (l--) {
        ans = ans << 1;
        if (ans > ing) {
            return ing;
        }
    }
    return ans;
}

int ch(int time) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] <= time && time < a[i] + t[i]) {
            ++ans;
        } else if (a[i] + t[i] <= time) {
            ans += pw(time - (a[i] + t[i]) + 1);
        }
        if (ans > ing) {
            return ing + 1;
        }
    }
    return ans;
}

signed main() {
    fast_in_out();
    int M;
    cin >> n >> M;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    int l = 0, r = 1e15;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (ch(m) >= M) {
            r = m;
        } else {
            l = m;
        }
    }
    if (ch(r) == M) {
        cout << r;
    } else {
        cout << -1;
    }
    return 0;
}