#include <bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

using ll = long long;
#define int long long

struct node {
    node *l = nullptr, *r = nullptr, *par = nullptr;
    int x = -1, sz = 1;

    node() {}

};

vector<node *> a;

int getsz(node *v) {
    if (v == nullptr) {
        return 0;
    }
    return v->sz;
}

vector<node *> Getpos;

void getpos(node *v) {
    if (v == nullptr) {
        return;
    }
    if (v->x == -1) {
        Getpos.emplace_back(v);
        getpos(v->l);
        getpos(v->r);
    } else if (v->x == 0) {
        getpos(v->l);
        Getpos.emplace_back(v);
        getpos(v->r);
    } else {
        getpos(v->l);
        getpos(v->r);
        Getpos.emplace_back(v);
    }
}

void Dfs(node *v) {
    if (v == nullptr) {
        return;
    }
    Dfs(v->l);
    Dfs(v->r);
    v->sz = getsz(v->l) + getsz(v->r);
}

signed main() {
    fast_in_out();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        node *nd = new node();
        a.emplace_back(nd);
    }
    for (int i = 0; i < n; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        if (q != -1) {
            a[i]->l = a[q];
            a[q]->par = a[i];
        }
        if (w != -1) {
            a[i]->r = a[w];
            a[w]->par = a[i];
        }
    }
    for (int qwe = 0; qwe < m; ++qwe) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            --l, --r;
            for (int i = l; i <= r; ++i) {
                a[i]->x = x;
            }
        } else {
            int v;
            cin >> v;
            --v;
            getpos(a[0]);
            int pos = 0;
            while (Getpos[pos] != a[v]) {
                ++pos;
            }
            cout << pos + 1 << '\n';
            Getpos.clear();
        }
    }
    return 0;
}