#include <bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

using ll = long long;
#define int long long

struct node {
    node *l = nullptr, *r = nullptr, *par = nullptr;
    int x = -1, sz = 1;

    node() {}

};

vector<node *> a;

int getsz(node *v) {
    if (v == nullptr) {
        return 0;
    }
    return v->sz;
}

int getpos(node *v) {
    vector<node *> vec;
    node *t = v;
    while (t != nullptr) {
        vec.emplace_back(t);
        t = t->par;
    }
    reverse(vec.begin(), vec.end());
    int k = 1;
    for (int i = 0; i < (int) vec.size() - 1; ++i) {
        if (vec[i]->l == vec[i + 1]) {
            k += (vec[i]->x == -1);
        } else {
            k += getsz(vec[i]->l) + (vec[i]->x != 1);
        }
    }
    k += (v->x != -1) * getsz(v->l);
    k += (v->x == 1) * getsz(v->r);
    return k;
}

void Dfs(node *v) {
    if (v == nullptr) {
        return;
    }
    Dfs(v->l);
    Dfs(v->r);
    v->sz = getsz(v->l) + getsz(v->r) + 1;
}

signed main() {
    fast_in_out();
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        node *nd = new node();
        a.emplace_back(nd);
    }
    for (int i = 0; i < n; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        if (q != -1) {
            a[i]->l = a[q];
            a[q]->par = a[i];
        }
        if (w != -1) {
            a[i]->r = a[w];
            a[w]->par = a[i];
        }
    }
    Dfs(a[0]);
    for (int qwe = 0; qwe < m; ++qwe) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            --l, --r;
            for (int i = l; i <= r; ++i) {
                a[i]->x = x;
            }
        } else {
            int v;
            cin >> v;
            --v;
            cout << getpos(a[v]) << '\n';
        }
    }
    return 0;
}