#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
const int N = 15;
int a[N][N], h, w, s;

signed main() {
    fast_in_out();
    cin >> h >> w;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
        }
    }
    cin >> s;
    for (int mask = 0; mask < (1 << (w + h)); ++mask) {
        int sum = 0;
        for (int j = 0; j < w; ++j) {
            if (!((mask >> j) & 1)) {
                for (int i = 0; i < h; ++i) {
                    if (!((mask >> (i + w)) & 1)) {
                        sum += a[i][j];
                    }
                }
            }
        }
        if (sum != s) {
            continue;
        }
        vector<pair<int, int>> ans;
        for (int j = 0; j < w; ++j) {
            if (((mask >> j) & 1)) {
                ans.emplace_back(2, j + 1);
            }
        }
        for (int i = 0; i < h; ++i) {
            if (((mask >> (i + w)) & 1)) {
                ans.emplace_back(1, i + 1);
            }
        }
        cout << "YES\n" << (int) ans.size() << '\n';
        for (auto [it1, it2]: ans) {
            cout << it1 << ' ' << it2 << '\n';
        }
        return 0;
    }
    cout << "NO";
    return 0;
}
