#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
vector<pair<int, int>> qwe = {{-1, -1}};
int h;

vector<pair<int, int>> f(vector<int> p, int s) {
    int sum = 0;
    for (auto it: p) {
        sum += it;
    }
    if (sum < s) {
        return qwe;
    }
    int K = h / 2;
    unordered_map<int, int> mp1, mp2;
    for (int mask = 0; mask < (1 << K); ++mask) {
        int sm = 0, pos = -1;
        for (int j = 0; j < K; ++j) {
            if (!((mask >> j) & 1)) {
                sm += p[j];
                pos = j;
            }
        }
        if (sm <= s)
            mp1[sm] = pos;
    }
    for (int mask = 0; mask < (1 << (h - K)); ++mask) {
        int sm = 0, pos = -1;
        for (int j = 0; j < (h - K); ++j) {
            if (!((mask >> j) & 1)) {
                sm += p[j + K];
                pos = j + K;
            }
        }
        if (sm <= s)
            mp2[sm] = pos;
    }
    for (auto [f1, s1]: mp1) {
        if (mp2.find(s - f1) != mp2.end()) {
            auto [f2, s2] = *mp2.find(s - f1);
            vector<pair<int, int>> ans;
            set<int> st;
            int pos = mp1[f1], S = f1;
            st.insert(pos);
            while (pos != -1) {
                int pos1 = mp1[S - p[pos]];
                S = S - p[pos];
                pos = pos1;
                if (pos == -1) {
                    break;
                }
                st.insert(pos);
            }
            pos = mp2[f2], S = f2;
            st.insert(pos);
            while (pos != -1) {
                int pos1 = mp2[S - p[pos]];
                S = S - p[pos];
                pos = pos1;
                if (pos == -1) {
                    break;
                }
                st.insert(pos);
            }
            for (int i = 0; i < h; ++i) {
                if (st.find(i) == st.end()) {
                    ans.emplace_back(1, i + 1);
                }
            }
            return ans;
        }
    }
    return qwe;
}

const int N = 15;
int a[N][N], w, s;

signed main() {
    fast_in_out();
    cin >> h >> w;
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
        }
    }
    cin >> s;
    for (int mask = 0; mask < (1 << w); ++mask) {
        vector<int> p(h);
        for (int j = 0; j < w; ++j) {
            if (!((mask >> j) & 1)) {
                for (int i = 0; i < h; ++i) {
                    p[i] += a[i][j];
                }
            }
        }
//        if (mask) {
//            cout << 0;
//        }
        vector<pair<int, int>> ans = f(p, s);
        if (ans == qwe) {
            continue;
        }
        for (int j = 0; j < w; ++j) {
            if (((mask >> j) & 1)) {
                ans.emplace_back(2, j + 1);
            }
        }
        cout << "YES\n" << (int) ans.size() << '\n';
        for (auto [it1, it2]: ans) {
            cout << it1 << ' ' << it2 << '\n';
        }
        return 0;
    }
    cout << "NO";
    return 0;
}