#include <bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

using ll = long long;
#define int long long
const int N = 3e5, mod = 1e9 + 7;
vector<int> a;
map<int, int> mp;
int n;

int f(vector<int> b) {
    if ((int) b.size() < 3) {
        return 1;
    }
    vector<vector<int>> dp(n + 1, vector<int>(n + 1)), dp2 = dp;
    dp[b[0]][b[1]] = 1;
    for (int s = 2; s < (int) b.size(); ++s) {
        vector<vector<int>> dp1 = dp2;
        for (int i = 0; i <= b[s - 2]; ++i) {
            for (int j = 0; j <= b[s - 1]; ++j) {
                for (int k = 0; k <= min({i, j, b[s]}); ++k) {
                    dp1[j - k][b[s] - k] += dp[i - k][j - k];
                    dp1[j - k][b[s] - k] %= mod;
                }
            }
        }
        dp = dp1;
    }
    int ans = 0;
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < n + 1; ++j) {
            ans += dp[i][j];
            ans %= mod;
        }
    }
    return ans;
}

signed main() {
    fast_in_out();
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        mp[x]++;
    }
    vector<pair<int, int>> b;
    for (auto [it1, it2]: mp) {
        b.emplace_back(it1, it2);
    }
    for (int i = 0; i < (int) b.size(); ++i) {
        if (b[i].second < 0) {
            cout << 0;
            return 0;
        }
        int k = b[i].second % 3;
        if (k != 0) {
            if (i + 2 >= (int) b.size()) {
                cout << 0;
                return 0;
            }
            b[i].second -= k;
            b[i + 1].second -= k;
            b[i + 2].second -= k;
        }
    }
    int ans = 1;
    for (int i = 0; i < (int) b.size(); ++i) {
        for (int j = 0; j < b[i].second; ++j) {
            a.emplace_back(b[i].first);
        }
    }
    n = (int) a.size();
    mp.clear();
    for (int i = 0; i < n; ++i) {
        mp[a[i]]++;
    }
    b.clear();
    for (auto [it1, it2]: mp) {
        b.emplace_back(it1, it2 / 3);
    }
    for (int qwe = 0; qwe < (int) b.size(); ++qwe) {
        int qwe1 = qwe;
        vector<int> c;
        c.emplace_back(b[qwe1].second);
        while (qwe1 + 1 < (int) b.size() && b[qwe1].first + 1 == b[qwe1 + 1].first) {
            ++qwe1;
            c.emplace_back(b[qwe1].second);
        }
        ans *= f(c);
        qwe = qwe1;
    }
    cout << ans;
    return 0;
}